#include <windows.h>
#include <stdio.h>

HINSTANCE hInstance;
WNDPROC originalButtonProc;

typedef void(*PINITCOMMONCONTROLS)(void);

HRESULT
WINAPI
btnWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    // printf("Triggered\n");
    // SetWindowLongPtrA(hWnd, GWL_WNDPROC, (ULONG_PTR)originalButtonProc);
    return CallWindowProcA(originalButtonProc, hWnd, msg, wParam, lParam);
}

HRESULT
WINAPI
windowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    return DefWindowProc(hWnd, msg, wParam, lParam);
}

int
WINAPI
WinMain(HINSTANCE hInst,
        HINSTANCE hPrevInst,
        LPSTR lpCmdLine,
        int nCmdShow)
{
    HANDLE hComctl;
    PINITCOMMONCONTROLS pCtl;
    HWND hWindow, buttonWnd;
    WNDCLASSA class, class2;
    MSG msg;
#ifdef _ON_WINDOWS
    hComctl = LoadLibrary("./comctl32.dll");
    //pCtl = (PINITCOMMONCONTROLS)GetProcAddress(hComctl, "InitCommonControls");
    //pCtl();
#else
    hComctl = LoadLibrary("comctl32.dll");
#endif
    hInstance = hInst;
    /* Register window class */
    RtlZeroMemory(&class, sizeof(WNDCLASSA));
    RtlZeroMemory(&class2, sizeof(WNDCLASSA));
    class.lpfnWndProc = DefWindowProcA;
    class.hInstance = hInst;
    class.lpszClassName = "MyWnd";
    class.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    RegisterClassA(&class);

    GetClassInfoA(hInst, "BUTTON", &class2);
    originalButtonProc = class2.lpfnWndProc;

    class2.lpszClassName = "MyButton";
    class2.lpfnWndProc = btnWndProc;
    if(!RegisterClassA(&class2))
    {
        printf("Aaaargh %x\n", GetLastError());
    }

    hWindow = CreateWindowA(
            "MyWnd",
            "Hello, test",
            WS_CAPTION | WS_VISIBLE,
            10,
            10,
            200,
            100,
            NULL,
            NULL,
            hInst,
            0);
 
    buttonWnd = CreateWindow(
            "MyButton",
            "This is a test",
            WS_CHILD | WS_VISIBLE,
            10,
            10,
            100,
            24,
            hWindow,
            NULL,
            hInstance,
            0);
    //SetWindowLongPtr(buttonWnd, GWL_WNDPROC, (LONG_PTR)btnWndProc);
    while(GetMessage(&msg, hWindow, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return 0;
}

